use utils::math::factorial;

fn main() {
    let result = smallest_multiple(20);
    println!("Result: {result}");
}

fn smallest_multiple(number: i64) -> i64 {
    let factorial = factorial(number.try_into().unwrap()) as i64;
    for i in number..=factorial {
        if is_multiple(i, number) {
            return i;
        }
    }

    factorial
}

fn is_multiple(number: i64, range: i64) -> bool {
    for i in 2..=range {
        if number % i != 0 {
            return false;
        }
    }
    true
}

#[cfg(test)]
mod tests {
    use crate::smallest_multiple;

    #[test]
    fn it_works() {
        let result = smallest_multiple(10);
        assert_eq!(result, 2520);
    }
}
